﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Action = Styx.TreeSharp.Action;
using Sequence = Styx.TreeSharp.Sequence;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
namespace TrapBuddy
{
    class TrapBuddy : BotBase
    {
        static int _trapType;
        WoWPoint _target;

        public override string Name
        {
            get { return "TrapBuddy"; }
        }
        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }
        public override void Pulse()
        {
            _trapType = Lua.GetReturnVal<int>("return trapNum", 0);
            if (StyxWoW.Me.FocusedUnit == null)
            {
                Lua.DoString("trapNum = 0;");
                _trapType = 0;
                return;
            }

            switch (_trapType)
            {
                case 1:
					SpellManager.Cast("Freezing Trap");
                    _target = GetPoint();
                    SpellManager.ClickRemoteLocation(_target);
                    Lua.DoString("trapNum = 0;");
                    _trapType = 0;
                    break;
                case 2:
					SpellManager.Cast("Explosive Trap");
                    _target = GetPoint();
                    SpellManager.ClickRemoteLocation(_target);
                    Lua.DoString("trapNum = 0;");
                    _trapType = 0;
                    break;
				case 3:
					SpellManager.Cast("Binding Shot");
                    _target = GetPoint();
                    SpellManager.ClickRemoteLocation(_target);
                    Lua.DoString("trapNum = 0;");
                    _trapType = 0;
                    break;	
			    case 4:
					SpellManager.Cast("Ice Trap");
                    _target = GetPoint();
                    SpellManager.ClickRemoteLocation(_target);
                    Lua.DoString("trapNum = 0;");
                    _trapType = 0;
                    break;
            }
        }
		
        private Composite _root;
		        
		public override Composite Root{get{return null;}}

        public override void Start(){ProfileManager.LoadEmpty();}
		
        static WoWPoint GetPoint()
        {
            var focus = StyxWoW.Me.FocusedUnit;
            return focus.Location;
        }
    }
}
